/**
 * Created by guosen on 2018/12/17.
 */

import et from  '__ROOTPATH__/H5_common/asset/common_tool/event.js';
import $ from  '__ROOTPATH__/H5_common/asset/common_tool/zepto.js';
import Com from '__ROOTPATH__/H5_common/asset/common_tool/app_common_bridge.js';
import Vue from 'vue';
import tool_fun from '__ROOTPATH__/H5_common/asset/common_tool/common_fun.js';
import Dialog from '__ROOTPATH__/H5_common/asset/common_tool/components/dialog/';//替换新弹窗组件原组件有兼容性

require('__ROOTPATH__/H5_common/asset/common_tool/common.css');
require('../css/common.scss');
require('../css/apply_content.scss');
const applyContentTpl = require('../tpl/apply_content.html');


const dataObj = {
	showChooseMask: false,
	holderList: [],
	showHolder: '',
	stockInfo: {},
	holderMarket: '',
	holderId: '',
	code: tool_fun.getParam('code'),
	type: tool_fun.getParam('type'),
	mapMarketName: {
		6: '特别转让A',
		7: '特别转让B'
	},
	price: '',
	count: ''

};
const configData = {
	applyUrl: '/zebra/gstrade/neeq/queryIssuePlan/1.0',
	holderList: [],
	mapStatus: {
		I: '公开发行询价',
		F: '公开发行申购',
		i: '公开发行询价',
		f: '公开发行申购',
		7: '可转债或可交换债发行',
		a: '新股发行'
	}
};
et.eventBind();
const exports = {
	init: function () {
		new Vue({
			el: '#domDiv',
			data: dataObj,
			methods:{
				//输入价格事件控制
				inputPriceEvent: function () {

				},
				inputCountEvent: function () {

				},
				formatNum: function (num) {
					if(!num) return '--';
					if(Number(num) < 10000) {
						return num;
					} else {
						return (Number(num) / 10000).toFixed(2) + '万'
					}

				},
				retStatus: function (ret) {
					return configData.mapStatus[ret] ? configData.mapStatus[ret] : '--';
				},
				formatDate: function (date) {
					if(!date) return;
					date = date + '';
					return date.substr(0, 4) + '/' + date.substr(4, 2) + '/' + date.substr(6, 2)

				}
			},
			template: '<div class="apply-pre">' + applyContentTpl + '</div>'
		});
		exports.getStockHolder();//获取股东号
		exports.getList();
		exports.bindEvent();
		if(dataObj.type == 'issue') {
			Com.setWebviewTitle('', {'title': '询价申报'});
		} else {
			Com.setWebviewTitle('', {'title': '申购申报'});
		}
	},
	bindEvent: function () {
		et.on('goto.sure.btn', function () {
			if(!dataObj.stockInfo.stkcode) return;
			if(!dataObj.price) {
				Dialog.alert({
					title: '',
					content: '请输入' + (dataObj.type == 'issue' ? '询价' : '申购') + '价格~',
					confirmText: '确定',
					onConfirm: () => {
					}
				})
				return;
			}
			if(!dataObj.count) {
				Dialog.alert({
					title: '',
					content: '请输入' + (dataObj.type == 'issue' ? '询价' : '申购') + '数量~',
					confirmText: '确定',
					onConfirm: () => {
					}

				})
				return;
			}
			let url = window.location.href.split('/pages')[0] + '/pages/apply_sure.html?type=' + dataObj.type
				+ '&code=' + dataObj.stockInfo.stkcode + '&name=' + dataObj.stockInfo.stkname + '&price=' + dataObj.price
				+ '&count=' + dataObj.count + '&status=' + dataObj.stockInfo.stkstatus + '&sid=' + dataObj.holderId + '&market=' + dataObj.holderMarket;
			Com.newWebViewOpenPage('', {'pageUrl': url, 'weburl': url});
		})
		et.on('choose.holder', function () {
			dataObj.showChooseMask = true;
		});
		et.on('choose.list.holder', function (e, t) {
			let id = t.attr('data-id');
			let market = t.attr('data-market');
			dataObj.holderMarket = market;
			dataObj.holderId = id;
			dataObj.showChooseMask = false;

		})
	},
	//获取股东账号
	getStockHolder: function (stkMarket, callback) {
		const random = '_' + (Math.random() + '').split('.')[1];
		const funName = 'setTradeLoginData' + random;
		configData.holderList = [];
		window.$js[funName] = function (tradeLoginData) {
			let shareHold = tradeLoginData.shareholderList;
			if(!shareHold) return;
			for(let i = 0; i < shareHold.length; i++) {
				if(shareHold[i].shareholderMarketId == '6' || shareHold[i].shareholderMarketId == '7'){
					configData.holderList.push({
						market: shareHold[i].shareholderMarketId,
						id: shareHold[i].shareholderId,
						isMaster: shareHold[i].shareholderSecuseq //0是主股东，1 不是
					});

				}
			}
			if(configData.holderList.length > 0){
				//dataObj.showHolder = configData.holderList[0].market + configData.holderList[0].id;
				dataObj.holderMarket = configData.holderList[0].market;
				dataObj.holderId = configData.holderList[0].id;
				dataObj.holderList = configData.holderList;
			}
			callback && callback();
		};
		//从native获取登录参数，判断是否存在尚未开通上海股东账户不能签约金天利
		onCallNative('DataService', 'getTradeLoginData', {}, funName, '{"shareholderList":[{"shareholderSecuseq":0,"shareholderId":"0000000346","shareholderMarketId":"7"},{"shareholderSecuseq":0,"shareholderId":"A45944417402","shareholderMarketId":"7"},{"shareholderSecuseq":0,"shareholderId":"01X2220117","shareholderMarketId":"6"}],"fundId":"110002345509","randomKey":"Fundid:1494529838:110002345509","orgId":"xxxx"}');

	},
	getList: function () {
		let reqParam ={
			qrytype: dataObj.type == 'apply' ? 2 : 1
		}

		exports.getData(configData.applyUrl, reqParam, function (data) {
			if(data.result && data.result[0].code == 0) {
				for(let i = 0; i < data.data.length; i++) {
					if(dataObj.code == data.data[i].stkcode) {
						dataObj.stockInfo = data.data[i];
						for(let i = 0; i < configData.holderList.length; i++) {
							if(dataObj.stockInfo.market == configData.holderList[i].market) {
								dataObj.holderMarket = configData.holderList[i].market;
								dataObj.holderId = configData.holderList[i].id;
								return;
							}
						}
					}
				}

			} else {
				Com.showNativeAlert('', data.result && data.result[0] && data.result[0].msg, ['确定'], '');
			}

		})

	},
	getData: function (url, reqParm, callback) {
		Com.ajax({
			'url': url,
			'data': reqParm,
			'type': 'post',
			'dataType': 'json',
			'success': function(data){
				callback && callback(data);
			},
			'isTradeLogin': true,//是否需要交易登录
			isNeedSign:true,
			'error': function (data, type, err) {
				if(type != 'abort') {
					Com.showNativeAlert('', '网络不给力' + data.status + ',' + data.statusText + ',' + data.readyState + '|'+ type + '|' + err, ['确定'], '');
				}
			}
		});
	},
}

exports.init();
