/**
 * Created by guosen on 2018/12/17.
 */

import et from  '__ROOTPATH__/H5_common/asset/common_tool/event.js';
import $ from  '__ROOTPATH__/H5_common/asset/common_tool/zepto.js';
import Com from '__ROOTPATH__/H5_common/asset/common_tool/app_common_bridge.js';
import Vue from 'vue';
import tool_fun from '__ROOTPATH__/H5_common/asset/common_tool/common_fun.js';

require('__ROOTPATH__/H5_common/asset/common_tool/common.css');
require('../css/common.scss');
require('../css/issue_apply_list.scss');
const tpl = require('../tpl/issue_apply_list.html');


const dataObj = {
	type: tool_fun.getParam('type'),
	list: ['']
};
const configData = {
	applyUrl: '/zebra/gstrade/neeq/queryIssuePlan/1.0',
	mapStatus: {
		I: '公开发行询价',
		F: '公开发行申购',
		i: '公开发行询价',
		f: '公开发行申购'
	}

};
et.eventBind();
const exports = {
	init: function () {
		new Vue({
			el: '#domDiv',
			data: dataObj,
			methods:{
				formatNum: function (num) {
					if(!num) return '--';
					if(Number(num) < 10000) {
						return num;
					} else {
						return (Number(num) / 10000).toFixed(2) + '万'
					}

				},
				retStatus: function (ret) {
					return configData.mapStatus[ret] ? configData.mapStatus[ret] : '--';
				},
				formatDate: function (date) {
					if(!date) return;
					date = date + '';
					return date.substr(0, 4) + '/' + date.substr(4, 2) + '/' + date.substr(6, 2)

				}
			},
			template: '<div >' + tpl + '</div>'
		});
		if(dataObj.type == 'apply') {
			Com.setWebviewTitle('', {'title': '新股申购'});
		} else {
			Com.setWebviewTitle('', {'title': '发行询价'});
		}
		exports.getList();
		exports.bindEvent();
	},
	bindEvent: function () {
		et.on('goto.apply', function (e, t) {
			let code = t.attr('data-code');
			let url = window.location.href.split('/pages')[0] + '/pages/apply_content.html?code=' + code + '&type=' + dataObj.type;
			Com.newWebViewOpenPage('', {'pageUrl': url, 'weburl': url});
		})
	},
	getList: function () {
		let reqParam ={
			qrytype: dataObj.type == 'apply' ? 2 : 1
		}

		exports.getData(configData.applyUrl, reqParam, function (data) {
				if(data.result && data.result[0].code == 0) {
					dataObj.list = data.data;

				} else {
					Com.showNativeAlert('', data.result && data.result[0] && data.result[0].msg, ['确定'], '');
				}

		})

	},
	getData: function (url, reqParm, callback) {
		Com.ajax({
			'url': url,
			'data': reqParm,
			'type': 'post',
			'dataType': 'json',
			'success': function(data){
				callback && callback(data);
			},
			'isTradeLogin': true,//是否需要交易登录
			isNeedSign:true,
			'error': function (data, type, err) {
				if(type != 'abort') {
					Com.showNativeAlert('', '网络不给力' + data.status + ',' + data.statusText + ',' + data.readyState + '|'+ type + '|' + err, ['确定'], '');
				}
			}
		});
	},
}

exports.init();
