/**
 * Created by guosen on 2018/12/17.
 */

import et from  '__ROOTPATH__/H5_common/asset/common_tool/event.js';
import $ from  '__ROOTPATH__/H5_common/asset/common_tool/zepto.js';
import Com from '__ROOTPATH__/H5_common/asset/common_tool/app_common_bridge.js';
import Vue from 'vue';
require('__ROOTPATH__/H5_common/asset/common_tool/common.css');
require('../css/common.scss');
require('../css/issue_result_search.scss');
const tpl = require('../tpl/issue_result_search.html');
import TabBar from '__ROOTPATH__/H5_common/asset/common_tool/components/tab-bar/';
import tool_fun from '__ROOTPATH__/H5_common/asset/common_tool/common_fun.js';


const dataObj = {
	currentTab: 0, //初始化显示那个Tab
	tabMenu: [
		{name: 0, label: '可申购'},
		{name: 1, label: '自定义'},
	],
	applyMenu: [
		{name: 0, label: '7日'},
		{name: 1, label: '30日'},
		{name: 2, label: '自定义'},
	],
	type: tool_fun.getParam('type'),
	mapStatus: {
		0: '成功',
		2: '失败'
	},
	list: ['']
};
const configData = {
	queryOrderUrl: '/zebra/gstrade/neeq/queryEnquiryResult/1.0',
	queryHisUrl: '/zebra/gstrade/neeq/queryEnquiryHis/1.0',
	applyHisUrl: '/zebra/gstrade/neeq/queryHitHis/1.0',
	strdate: '',
	enddate: '',
	poststr: ''

};
et.eventBind();
const exports = {
	init: function () {
		new Vue({
			el: '#domDiv',
			data: dataObj,
			components:{
				[TabBar.name]: TabBar,
			},
	        methods: {
		        changeApplyTabMenu (tab) {
			        if(tab.name != dataObj.currentTab) {

				        if(tab.name == '2') {
					        dataObj.list = [];
				        } else {
					        dataObj.list = [''];
				        }
			        } else {
				        if(tab.name != '2') {
					        return;
				        }
			        }

			        switch (Number(tab.name)) {
				        case 0:
					        exports.getDate(7);
					        exports.getApplyHis();
					        break;
				        case 1:
					        exports.getDate(30);
					        exports.getApplyHis();
					        break;
				        default:
					        var random = '_' + (Math.random() + '').split('.')[1];
					        var callbackName = 'transitionDateSelectFinish';
					        $js[callbackName] = function(d) {

						        configData.strdate = d.strDate;
						        configData.enddate = d.endDate;
						        exports.getHisList();
					        };
					        onCallNative('WebContainer', 'transitionQueryDateSelect', {
							        "strDate":configData.strdate,
							        "endDate":configData.enddate,
							        "needStkCode":"false"
						        },callbackName
					        );
					        break;

			        }
			        configData.strdate = '';
			        configData.enddate = '';

		        },
		        changeTabMenu (tab) {
			        if(tab.name != dataObj.currentTab) {
				        if(tab.name == '1') {
					        dataObj.list = [];
				        } else {
					        dataObj.list = [''];
				        }

			        } else {
				        if(tab.name != '1') {
					        return;
				        }

			        }
			        if(tab.name == '1') {//自定义
				        var random = '_' + (Math.random() + '').split('.')[1];
				        var callbackName = 'transitionDateSelectFinish';
				        $js[callbackName] = function(d) {

					        configData.strdate = d.strDate;
					        configData.enddate = d.endDate;
					        exports.getHisList();
				        };
				        onCallNative('WebContainer', 'transitionQueryDateSelect', {
						        "strDate":configData.strdate,
						        "endDate":configData.enddate,
						        "needStkCode":"false"
					        },callbackName
				        );
			        } else {//可申购
				        exports.getList();
			        }
			        configData.strdate = '';
			        configData.enddate = '';

                },
	        },
			template: '<div class="apply-pre">' + tpl + '</div>'
		});
		if(dataObj.type == 'issue') {
			Com.setWebviewTitle('', {'title': '询价结果查询'});
		} else {
			Com.setWebviewTitle('', {'title': '申购配售结果查询'});
		}
		if(dataObj.type == 'issue') {
			exports.getList();
		} else {
			exports.getDate(7);
			exports.getApplyHis();
		}

		exports.bindEvent();
	},
	getDate: function (time) {
		let startT = new Date();
		let endT = startT.getTime() - Number(time) * 24 * 60 * 60 * 1000;
		configData.enddate = startT.format('%Y%M%d', true);
		configData.strdate = new Date(endT).format('%Y%M%d', true);
	},
	getApplyHis: function () {
		let reqParam = {
			strdate: configData.strdate,
			enddate: configData.enddate,
			qryflag: '1',
			count: 1000,
			poststr: configData.poststr,
			qrytype: 3
		}
		exports.getData(configData.applyHisUrl, reqParam, function (data) {
			if(data.result && data.result[0].code == 0) {
				dataObj.list = data.data;
			} else {
				Com.showNativeAlert('', data.result && data.result[0] && data.result[0].msg, ['确定'], '');
			}
		})
	},
	getHisList: function () {
		let reqParam = {
			strdate: configData.strdate,
			enddate: configData.enddate,
			count: 1000,
			poststr: ' '
		}
		exports.getData(configData.queryHisUrl, reqParam, function (data) {
			if(data.result && data.result[0].code == 0) {
				dataObj.list = data.data;
			} else {
				Com.showNativeAlert('', data.result && data.result[0] && data.result[0].msg, ['确定'], '');
			}
		})
	},
	getList: function () {
		let reqParam = {
			qryflag: '1',
			count: 1000,
			poststr: ''
		}
		exports.getData(configData.queryOrderUrl, reqParam, function (data) {
			if(data.result && data.result[0].code == 0) {
				dataObj.list = data.data;
			} else {
				Com.showNativeAlert('', data.result && data.result[0] && data.result[0].msg, ['确定'], '');
			}
		})

	},
	bindEvent: function () {
		et.on('goto.detail', function (e, t) {
			let index = t.attr('data-index');
			let url = window.location.href.split('/pages')[0] + '/pages/apply_detail.html?type=' + dataObj.type + '&param=' + Com.bse64Encode(encodeURIComponent(JSON.stringify(dataObj.list[index])));
			Com.newWebViewOpenPage('', {'pageUrl': url, 'weburl': url});

		})
	},
	getData: function (url, reqParm, callback) {
		Com.ajax({
			'url': url,
			'data': reqParm,
			'type': 'post',
			'dataType': 'json',
			'success': function(data){
				Com.ajaxLoaded();
				callback && callback(data);
			},
			'isTradeLogin': true,//是否需要交易登录
			isNeedSign:true,
			'error': function (data, type, err) {
				Com.ajaxLoaded();
				if(type != 'abort') {
					Com.showNativeAlert('', '网络不给力' + data.status + ',' + data.statusText + ',' + data.readyState + '|'+ type + '|' + err, ['确定'], '');
				}
			}
		});
	},
}

exports.init();
