/**https://github.com/lxw666/slider.js
 * @param	maxNum 传入最大数字
 * @param	minNum 传入最小刻度数字
 * @param	stepNum 每一个刻度代表多少数字
 * @param	stepWidth 每一个刻度的宽
 * @param   setSliderItemNum 初始化刻度尺刻度数量以及适时滑动增加的固定数量，防止大数据造成for循环过多造成浏览器崩溃,小于1000
 * @param	sliderItemStep 每隔多少隔显示长刻度
 * @param	sliderItemValueIsHidden 短刻度下面的标度是否显示
 * @param	sliderItemLongValueIsHidden 长刻度下面的标度是否显示
 * @param	sliderItemValueTextAlign 设置标度居中方式
 * @param	sliderGuide 设置指针是否显示
 * @param	setMaxNum 最大刻度数字
 * @param	setMinNum 最小刻度数字
 * @param	getSliderGuideLeftDeviation 指针偏移距离
 * @param   animatedClassName 刻度尺动画
 * @param	callBack 回调函数
 * @param   getAllSliderItemNum 刻度尺总个数
 * @param	startPageX 初始鼠标的水平位置
 * @param	startLeft 元素初始left
 * @param	movePageX 移动过程中鼠标的水平位置
 * @param	moveX 元素移动的距离
 * @param   forIndex loadMoreSlider方法的触发次数
 * @param	initClassName 元素初始className
 * @param	sliderid 中间红色选中长刻度的id
 **/
(function(){
	var Slider = function(options){
		this.id = options.id;
		this.getObj = document.getElementById(options.id);
		this.maxNum = options.maxNum;
		this.minNum = options.minNum;
		this.stepNum = options.stepNum;
		this.stepWidth = options.stepWidth;
		this.setSliderItemNum = options.setSliderItemNum;
		this.sliderItemStep = options.sliderItemStep;
		this.sliderItemValueIsHidden = options.sliderItemValueIsHidden;
		this.sliderItemLongValueIsHidden = options.sliderItemLongValueIsHidden;
		this.sliderItemValueTextAlign = options.sliderItemValueTextAlign;
		this.sliderGuide = options.sliderGuide;
		this.animatedClassName = options.animatedClassName || '';
		this.callBack = options.callBack;
		this.setMaxNum = Math.ceil((this.maxNum - this.minNum)/this.stepNum) * this.stepNum + this.minNum;
		this.setMinNum = this.minNum;
		this.getSliderGuideLeftDeviation = 0;
		this.initClassName = this.getObj.className;
		this.forIndex = 1;
		this.startPageX;
		this.startLeft;
		this.movePageX;
		this.moveX;
		this.sliderid =  options.sliderid;/*这个是我自己加的，原来的插件里面指针对象是写死的在代码里的，我把他改成动态属性可配置*/
		this.defaultvalue = options.defaultvalue || 0;/*该属性是我自己加的，便于初始化时指针指向的刻度值*/
		this.currentMoveX = 0;
		this.init();
	}
	Slider.prototype = {
		init: function(){
			this.getAllSliderItemNum = (this.setMaxNum - this.setMinNum)/this.stepNum,//滑尺刻度总个数
			this.setSliderItemNum = this.setSliderItemNum >= Math.ceil(document.body.offsetWidth/this.stepWidth)?this.setSliderItemNum : Math.ceil(document.body.offsetWidth/this.stepWidth);//初始化滑尺个数是否沾满一屏，否的话设置
			this.setSliderGuide();
			this.initSlider();
			this.defaultGuideValue();
		},
		initSlider: function(){
			var that = this,
				getSliderItemNum = that.setSliderItemNum > that.getAllSliderItemNum?that.getAllSliderItemNum:that.setSliderItemNum,//滑尺刻度总个数
				setObjWidth = that.stepWidth * that.getAllSliderItemNum,//滑尺总宽度
				sliderItemLeft,//每个刻度的left
				sliderItemValue,//每个刻度代表的value
				strHtml = '',
				spanAllHtml = '';
			that.getObj.style.width = setObjWidth + 'px';
			that.getObj.style.left = that.getSliderGuideLeftDeviation + 'px';
			for(var i = 0; i<=getSliderItemNum; i++){
				sliderItemLeft = that.stepWidth * i;
				sliderItemValue = that.setMinNum + that.stepNum * i;
				if(i%that.sliderItemStep === 0){
					strHtml = '<span class="slider-item-long" data-index="'+ i +'" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;"></span>';
					strHtml += that.sliderItemLongValueIsHidden?'<span class="slider-item-value" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;">'+ sliderItemValue +'</span>':'';
				}else{
					strHtml = '<span class="slider-item" data-index="'+ i +'" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;"></span>';
					strHtml += that.sliderItemValueIsHidden?'<span class="slider-item-value" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;">'+ sliderItemValue +'</span>':'';
				}
				spanAllHtml = spanAllHtml + strHtml;
			}
			that.getObj.innerHTML = '<div class="slider-item-box" id="sliderItemBox">'+ spanAllHtml +'</div>';
			that.setSliderGuideBorderBottom(setObjWidth);
			that.setSliderGuideDataValue();
			that.setSliderItemValueTextAlign();
			that.touch();
		},
		/*此处是自己加的代码，为了初始指向默认配置的刻度options.defaultvalue,开始*/
		defaultGuideValue:function(){
			var that = this;
			if(that.defaultvalue*1>0){
				that.durGuide = Math.abs(that.checkedDataValue-that.defaultvalue)/that.stepNum;/*当前指向的客户和1000差几个刻度*/
				that.durNum = that.durGuide*that.stepWidth;/*每个刻度是10的宽度，得到总位移*/
				that.getObj.style.left = that.getSliderGuideLeftDeviation+that.durNum + 'px';
				that.currentMoveX = that.getSliderGuideLeftDeviation+that.durNum;
				that.setSliderGuideDataValue(that.defaultvalue);//把红色指针当前指向的value改变一下
			}
		},
		/*此处是自己加的代码，为了初始指向1000的刻度,结束*/
		loadMoreSlider: function(){
			var that = this,
				getBodyWidth = document.body.offsetWidth,
				getSliderIndex = Math.round((getBodyWidth/2-that.getObj.offsetLeft)/that.stepWidth),
				getSliderItemNum = that.setSliderItemNum,
				sliderItemBox = document.getElementById('sliderItemBox'),
				sliderItemIndex,//新增的每个刻度代表的index
				sliderItemLeft,//新增的每个刻度的left
				sliderItemValue,//新增的每个刻度代表的value
				strHtml = '',
				spanAllHtml = sliderItemBox.innerHTML,
				startIndex = that.forIndex * getSliderItemNum;

			if(getSliderIndex >= (getSliderItemNum * (that.forIndex-1) + Math.round(getSliderItemNum/2))){
				for(var i = 1; i<=getSliderItemNum; i++){
					sliderItemIndex = i + getSliderItemNum * that.forIndex;
					sliderItemLeft = that.stepWidth * sliderItemIndex;
					sliderItemValue = that.setMinNum + that.stepNum * sliderItemIndex;
					console.log(sliderItemValue,that.setMaxNum)
					if(sliderItemValue <= that.setMaxNum){
						if(i%that.sliderItemStep === 0){
							strHtml = '<span class="slider-item-long" data-index="'+ sliderItemIndex +'" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;"></span>';
							strHtml += that.sliderItemLongValueIsHidden?'<span class="slider-item-value" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;">'+ sliderItemValue +'</span>':'';
						}else{
							strHtml = '<span class="slider-item" data-index="'+ sliderItemIndex +'" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;"></span>';
							strHtml += that.sliderItemValueIsHidden?'<span class="slider-item-value" data-value="'+ sliderItemValue +'" style="left: '+ sliderItemLeft +'px;">'+ sliderItemValue +'</span>':'';
						}
						spanAllHtml = spanAllHtml + strHtml;
					}
				}
				that.forIndex += 1;
				sliderItemBox.innerHTML = spanAllHtml;
			}
		},
		setSliderGuideBorderBottom: function(width){
			var that = this,
				setBorderBottom = width,
				creatBorderHtml = document.createElement('div'),
				getHtml = document.getElementsByClassName('slider-border-bottom')[0];
			creatBorderHtml.classList.add('slider-border-bottom');
			creatBorderHtml.style.width = setBorderBottom + 'px';
			creatBorderHtml.style.top = that.getObj.offsetTop + that.getObj.offsetHeight + 'px';
			creatBorderHtml.style.left = 0 + 'px';
			that.getObj.parentNode.appendChild(creatBorderHtml);
		},
		setSliderGuide: function(){
			var that = this;
			if(that.sliderGuide){
				var getBodyWidth = document.body.offsetWidth,
					getObjTop = that.getObj.offsetTop,
					creatGuideHtml = document.createElement('div');
				creatGuideHtml.classList.add('slider-guide');
				//creatGuideHtml.id="sliderGuide";
				creatGuideHtml.id=that.sliderid;
				creatGuideHtml.setAttribute('data-value','');
				that.getObj.parentNode.appendChild(creatGuideHtml);
				//var getSliderGuideDom = document.getElementById('sliderGuide'),
				var getSliderGuideDom = document.getElementById(that.sliderid),
					getSliderGuideDomHeight = getSliderGuideDom.offsetHeight;
				that.getSliderGuideLeftDeviation = (getBodyWidth/2)%that.stepWidth;
				getSliderGuideDom.style.top = getObjTop - getSliderGuideDomHeight + that.getObj.offsetHeight + 'px';
				getSliderGuideDom.style.left = getBodyWidth/2 + 'px';
				//console.log(that.getSliderGuideLeftDeviation)
			}
		},
		setSliderGuideDataValue: function(value){
			var that = this,
				getBodyWidth = document.body.offsetWidth,
				//getSliderGuideDom = document.getElementById('sliderGuide');
				getSliderGuideDom = document.getElementById(that.sliderid);
			if(!(value) && value != 0){
				/*初始化指针指向的value*/
				value = parseInt(getBodyWidth/2/that.stepWidth) * that.stepNum + that.setMinNum;
			}
			getSliderGuideDom.setAttribute('data-value',value);
			/*这里是我自己添加的代码，把初始化的value暴露出来*/
			that.checkedDataValue=value;
			/*结束*/
			that.callBack(value);
		},
		setSliderItemValueTextAlign: function(){
			var that = this,
				getItemAll = document.getElementsByClassName('slider-item-value'),
				getItemWidth;
			if(getItemAll && getItemAll.length > 0){
				for(var i=0,len=getItemAll.length; i<len; i++){
					getItemWidth = getItemAll[i].offsetWidth;
					// console.log(getItemWidth)
					switch(that.sliderItemValueTextAlign){
						case 'center':
							getItemAll[i].style.marginLeft = -getItemWidth/2 + 'px';
							break;
						case 'right':
							getItemAll[i].style.marginLeft = -getItemWidth + 'px';
							break;
						case 'left':
							getItemAll[i].style.marginLeft = 0 + 'px';
							break;
					}
				}
			}
		},
		touch: function(){
			var that = this;
			that.getObj.addEventListener('touchstart',function(e){
				e.preventDefault();
				e.stopPropagation();
				var startTouch = e.changedTouches[0];
				that.startPageX = startTouch.pageX;
				that.startLeft = this.offsetLeft;
				this.className = that.initClassName;
				console.log('touchstart',startTouch.pageX,that.animatedClassName,this.className)
			},false)
			that.getObj.addEventListener('touchmove',function(e){
				e.preventDefault();
				e.stopPropagation();
				var moveTouch = e.changedTouches[0],
					getBodyWidth = document.body.offsetWidth,
					left;
				that.movePageX = moveTouch.pageX;
				that.moveX = that.movePageX - that.startPageX;
				left = that.startLeft + that.moveX;
				var sliderMoveStopFlag = (getBodyWidth/2 - that.startLeft - that.moveX)/that.stepWidth * that.stepNum + that.setMinNum;
				// console.log(that.moveX,left,sliderMoveStopFlag)
				if(sliderMoveStopFlag < that.setMinNum){
					left = getBodyWidth/2;
				}else if(sliderMoveStopFlag > that.setMaxNum){
					left = getBodyWidth/2 - that.getObj.offsetWidth;
				}
				that.getObj.style.left = left + 'px';
			},false)
			that.getObj.addEventListener('touchend',function(e){
				e.preventDefault();
				e.stopPropagation();
				var moveTouch = e.changedTouches[0],
					getBodyWidth = document.body.offsetWidth,
					left,
					getInteget,//取整
					getRemainder,//取余
					SliderGuideDataValue;//指针所指的value
				this.className += ' ' + that.animatedClassName;
				console.log(this.className)
				that.movePageX = moveTouch.pageX;
				that.moveX = that.movePageX - that.startPageX;
				getInteget = parseInt(that.moveX/that.stepWidth);
				getRemainder = that.moveX % that.stepWidth;
				// console.log('touchend',that.moveX,getRemainder)
				if(Math.abs(getRemainder)==0 && getInteget == 0){
					left = that.startLeft;
				}
				if(Math.abs(getRemainder) >= (that.stepWidth/2)){
					if(getRemainder > 0){
						left = that.startLeft + that.stepWidth*(getInteget + 1);//向右移动
					}else if(getRemainder < 0){
						left = that.startLeft + that.stepWidth*(getInteget - 1);//向左移动
					}
				}else{
					left = that.startLeft + that.stepWidth * getInteget;
					console.log()
				}
				left = Math.round((left-that.getSliderGuideLeftDeviation)/that.stepWidth) * that.stepWidth + that.getSliderGuideLeftDeviation //消除快速滑动产生的误差
				SliderGuideDataValue = Math.round((getBodyWidth/2-this.offsetLeft)/that.stepWidth) * that.stepNum + that.setMinNum;
				that.setSliderGuideDataValue(SliderGuideDataValue);
				that.loadMoreSlider();

				var sliderMoveStopFlag = (getBodyWidth/2 - that.startLeft - that.moveX)/that.stepWidth * that.stepNum + that.setMinNum;
				if(sliderMoveStopFlag < that.setMinNum){
					left = getBodyWidth/2;
				}else if(sliderMoveStopFlag > that.setMaxNum){
					left = getBodyWidth/2 - that.getObj.offsetWidth;
				}
				that.getObj.style.left = left + 'px';
				that.currentMoveX = left;
			},false)
		}
	}
	if(typeof module != 'undefined' && module.exports){
		module.exports = Slider;
	}else if(typeof define == 'function' && define.amd){
		define(function(){
			return Slider;
		})
	}else{
		window.Slider = Slider;
	}
})()